# -*- coding: utf-8 -*-
#!/usr/bin/env python

# =============================================================================
#
# Dialog implementation generated from a XDL file.
#
# Created: Mon Feb  8 06:16:21 2021
#      by: unodit 0.8.0
#
# WARNING! All changes made in this file will be overwritten
#          if the file is generated again!
#
# =============================================================================

import uno
import unohelper
from com.sun.star.awt import XActionListener
from com.sun.star.task import XJobExecutor

from com.sun.star.awt.MessageBoxButtons import BUTTONS_OK, BUTTONS_OK_CANCEL, BUTTONS_YES_NO, BUTTONS_YES_NO_CANCEL, BUTTONS_RETRY_CANCEL, BUTTONS_ABORT_IGNORE_RETRY
from com.sun.star.awt.MessageBoxButtons import DEFAULT_BUTTON_OK, DEFAULT_BUTTON_CANCEL, DEFAULT_BUTTON_RETRY, DEFAULT_BUTTON_YES, DEFAULT_BUTTON_NO, DEFAULT_BUTTON_IGNORE
from com.sun.star.awt.MessageBoxType import MESSAGEBOX, INFOBOX, WARNINGBOX, ERRORBOX, QUERYBOX

# -------------------------------------
# HELPERS FOR MRI AND  XRAY
# -------------------------------------

# Uncomment for MRI
# def mri(ctx, target):
#     mri = ctx.ServiceManager.createInstanceWithContext("mytools.Mri", ctx)
#     mri.inspect(target)

# Uncomment for Xray
# def xray(myObject):
#     try:
#         sm = uno.getComponentContext().ServiceManager
#         mspf = sm.createInstanceWithContext("com.sun.star.script.provider.MasterScriptProviderFactory", uno.getComponentContext())
#         scriptPro = mspf.createScriptProvider("")
#         xScript = scriptPro.getScript("vnd.sun.star.script:XrayTool._Main.Xray?language=Basic&location=application")
#         xScript.invoke((myObject,), (), ())
#         return
#     except:
#         raise _rtex("\nBasic library Xray is not installed", uno.getComponentContext())
# -------------------------------------------------------------------


class MyApp(unohelper.Base, XActionListener, XJobExecutor):
    """
    Class documentation...
    """
    def __init__(self, ctx=uno.getComponentContext()):
        self.LocalContext = ctx
        self.ServiceManager = self.LocalContext.ServiceManager
        self.Toolkit = self.ServiceManager.createInstanceWithContext("com.sun.star.awt.ExtToolkit", self.LocalContext)

        # -----------------------------------------------------------
        #               Create dialog and insert controls
        # -----------------------------------------------------------

        # --------------create dialog container and set model and properties
        self.DialogContainer = self.ServiceManager.createInstanceWithContext("com.sun.star.awt.UnoControlDialog", self.LocalContext)
        self.DialogModel = self.ServiceManager.createInstance("com.sun.star.awt.UnoControlDialogModel")
        self.DialogContainer.setModel(self.DialogModel)
        self.DialogModel.Name = "langselect"
        self.DialogModel.PositionX = "135"
        self.DialogModel.PositionY = "91"
        self.DialogModel.Width = 208
        self.DialogModel.Height = 40
        self.DialogModel.Closeable = True
        self.DialogModel.Moveable = True
        self.DialogModel.Title = "Select translation languages"

        
        # --------- create an instance of ListBox control, set properties ---
        self.fr = self.DialogModel.createInstance("com.sun.star.awt.UnoControlListBoxModel")

        self.fr.Name = "from"
        self.fr.TabIndex = 0
        self.fr.PositionX = "15"
        self.fr.PositionY = "10"
        self.fr.Width = 44
        self.fr.Height = 15
        self.fr.Dropdown = True
        self.fr.StringItemList = ('de', 'en', 'fr', 'it', 'es', 'fi', 'de', 'en', 'fr', 'it', 'es', 'gr', 'tr', 'ar', 'uz', 'zh-CN', 'zh-TW')

        # inserts the control model into the dialog model
        self.DialogModel.insertByName("from", self.fr)

        # --------- create an instance of ListBox control, set properties ---
        self.lang = self.DialogModel.createInstance("com.sun.star.awt.UnoControlListBoxModel")

        self.lang.Name = "lang"
        self.lang.TabIndex = 2
        self.lang.PositionX = "90"
        self.lang.PositionY = "10"
        self.lang.Width = 44
        self.lang.Height = 15
        self.lang.Dropdown = True
        self.lang.LineCount = 15
        self.lang.StringItemList = ('de', 'en', 'fr', 'it', 'es', 'fi', 'de', 'en', 'fr', 'it', 'es', 'gr', 'tr', 'ar', 'uz', 'zh-CN', 'zh-TW')

        # inserts the control model into the dialog model
        self.DialogModel.insertByName("lang", self.lang)

        # --------- create an instance of FixedText control, set properties ---
        self.Label1 = self.DialogModel.createInstance("com.sun.star.awt.UnoControlFixedTextModel")

        self.Label1.Name = "Label1"
        self.Label1.TabIndex = 1
        self.Label1.PositionX = "70"
        self.Label1.PositionY = "11"
        self.Label1.Width = 13
        self.Label1.Height = 13
        self.Label1.Label = "➜"

        # inserts the control model into the dialog model
        self.DialogModel.insertByName("Label1", self.Label1)

        # --------- create an instance of Button control, set properties ---
        self.ok = self.DialogModel.createInstance("com.sun.star.awt.UnoControlButtonModel")

        self.ok.Name = "ok"
        self.ok.TabIndex = 3
        self.ok.PositionX = "160"
        self.ok.PositionY = "10"
        self.ok.Width = 35
        self.ok.Height = 17
        self.ok.Label = "OK"

        # inserts the control model into the dialog model
        self.DialogModel.insertByName("ok", self.ok)

        # add the action listener
        self.DialogContainer.getControl('ok').addActionListener(self)
        self.DialogContainer.getControl('ok').setActionCommand('ok_OnClick')

        # --------- create an instance of Button control, set properties ---
        self.CommandButton1 = self.DialogModel.createInstance("com.sun.star.awt.UnoControlButtonModel")

        self.CommandButton1.Name = "CommandButton1"
        self.CommandButton1.TabIndex = 4
        self.CommandButton1.PositionX = "17"
        self.CommandButton1.PositionY = "62"
        self.CommandButton1.Width = 2
        self.CommandButton1.Height = 0
        self.CommandButton1.Label = "CommandButton1"

        # inserts the control model into the dialog model
        self.DialogModel.insertByName("CommandButton1", self.CommandButton1)

        # add the action listener
        self.DialogContainer.getControl('CommandButton1').addActionListener(self)
        self.DialogContainer.getControl('CommandButton1').setActionCommand('CommandButton1_OnClick')

    def showDialog(self):
        self.DialogContainer.setVisible(True)
        self.DialogContainer.createPeer(self.Toolkit, None)
        self.DialogContainer.execute()

    # --------- functions -----------------------

    def myFunction(self):
        # TODO: not implemented
        pass

    # --------- helpers -------------------------

    def messageBox(self, MsgText, MsgTitle, MsgType=MESSAGEBOX, MsgButtons=BUTTONS_OK):
        sm = self.LocalContext.ServiceManager
        si = sm.createInstanceWithContext("com.sun.star.awt.Toolkit", self.LocalContext)
        mBox = si.createMessageBox(self.Toolkit, MsgType, MsgButtons, MsgTitle, MsgText)
        mBox.execute()

    # -----------------------------------------------------------
    #               Action events
    # -----------------------------------------------------------

    def actionPerformed(self, oActionEvent):
    
        if oActionEvent.ActionCommand == 'ok_OnClick':
            self.ok_OnClick()

        if oActionEvent.ActionCommand == 'CommandButton1_OnClick':
            self.CommandButton1_OnClick()

    
    def ok_OnClick(self):
        self.DialogModel.Title = "It's Alive! - ok"
        self.messageBox("It's Alive! - ok", "Event: OnClick", INFOBOX)
        # TODO: not implemented

    def CommandButton1_OnClick(self):
        self.DialogModel.Title = "It's Alive! - CommandButton1"
        self.messageBox("It's Alive! - CommandButton1", "Event: OnClick", INFOBOX)
        # TODO: not implemented


def Run_MyApp(*args):

    try:
        ctx = remote_ctx                    # IDE
    except:
        ctx = uno.getComponentContext()     # UI

    # get desktop
    desktop = ctx.getByName("/singletons/com.sun.star.frame.theDesktop")

    # get document
    document = desktop.getCurrentComponent()

    app = MyApp(ctx=ctx)
    app.showDialog()


# Execute macro from LibreOffice UI (Tools - Macro)
g_exportedScripts = Run_MyApp,

# -------------------------------------
# HELPER FOR AN IDE
# -------------------------------------

if __name__ == "__main__":
    """ Connect to LibreOffice proccess.
    1) Start the office in shell with command:
    soffice "--accept=socket,host=127.0.0.1,port=2002,tcpNoDelay=1;urp;StarOffice.ComponentContext" --norestore
    2) Run script
    """
    import os
    import sys

    sys.path.append(os.path.join(os.path.dirname(__file__), 'pythonpath'))

    local_ctx = uno.getComponentContext()
    resolver = local_ctx.ServiceManager.createInstance("com.sun.star.bridge.UnoUrlResolver")
    try:
        remote_ctx = resolver.resolve("uno:socket,"
                                        "host=127.0.0.1,"
                                        "port=2002,"
                                        "tcpNoDelay=1;"
                                        "urp;"
                                        "StarOffice.ComponentContext")
    except Exception as err:
        print(err)

    Run_MyApp()
